//main.c

#include "GPL951_body.h"
#include "System\System.h"
#include "USB\USBD_Define.h"
#include "USB\USBD.h"

#define DEVICE_READ_ALLOW	0x1	
#define DEVICE_WRITE_ALLOW	0x2	

unsigned int     R_Write_protect;

void USB_Insert_TimeOut(void); 
void USB_Initial(void);
void SysInitial(void);
void SysIntoUSB(void);


/////////////////////////////User setting initial value start//////////////////////////////////////////
#define USB_Part0_Offset	0x00000000
#define USB_Part0_Size 		0x000A0000

str_USB_Lun_Info USB_Lun_Define[]=
{
	{0x00, LunType_CDROM		, USB_Part0_Offset, 	USB_Part0_Size, 	LunStatus_Normal},
}; 

extern void System_Initial(void);
/////////////////////////////User setting initial value end//////////////////////////////////////////	
int main()
{

    int Key;
    						
	Key = 0;
 	System_Initial();

	R_NAND_Present=1;
	R_Write_protect = 0x00;	
	MaxLUN = 0;

	USB_Initial();	

	__asm("fiq on");
	__asm("irq on");

	while(1)
	{		
		Key = SP_GetCh();				
		switch(Key)
		{										
			case 0x0100:
				break; 						
			case 0x0200:
				break;					
			case 0x0400:
				break;						
			case 0x0800:
				break;
			case 0x1000:
				break;					
			case 0x2000:
				break;		
			case 0x4000:
				break;		
			case 0x8000:
				break;																	
			default:
				break;				
		}
		USB_ServiceLoop(0);			//use usb loop		
		System_ServiceLoop();		//Keyboard Scan
		
		if(USBD_PlugIn)
		{
			//USB Plug in
		}
		else
		{
			//USB Plug out							
		}	
	}
	
	*P_USBD_Config=0x00;		//close USB
 	*P_USBD_INTEN=0x00;	
	return 0;   		
}



void USB_Insert_TimeOut(void)
{
	int temp;
	temp=*P_TimerA_Ctrl;
	*P_TimerA_Ctrl=temp;	//clear timerA int flag	
	R_USB_Suspend=1;
}

void USB_TimeOut_Enable(void)
{
	//*P_TimerA_Preload=(0x10000-(4096*10));
	*P_TimerA_Preload=(0x10000-(40960));
	*P_TimerA_Ctrl=0xe064;
}

void Sys_Exception(unsigned int errorcode)
{
	
	
}
